<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>VerGen.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.version.util</a> &gt; <span class="el_source">VerGen.java</span></div><h1>VerGen.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.version.util;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

<span class="nc" id="L27">public class VerGen {</span>
    private static final String PACKAGE_NAME = &quot;org.apache.zookeeper.version&quot;;
    private static final String TYPE_NAME = &quot;Info&quot;;

    static void printUsage() {
<span class="nc" id="L32">        System.out.print(&quot;Usage:\tjava  -cp &lt;classpath&gt; org.apache.zookeeper.&quot;</span>
                + &quot;version.util.VerGen maj.min.micro[-qualifier] rev buildDate&quot;);
<span class="nc" id="L34">        System.exit(1);</span>
<span class="nc" id="L35">    }</span>

    public static void generateFile(File outputDir, Version version, int rev, String buildDate)
    {
<span class="fc" id="L39">        String path = PACKAGE_NAME.replaceAll(&quot;\\.&quot;, &quot;/&quot;);</span>
<span class="fc" id="L40">        File pkgdir = new File(outputDir, path);</span>
<span class="pc bpc" id="L41" title="1 of 2 branches missed.">        if (!pkgdir.exists()) {</span>
            // create the pkg directory
<span class="fc" id="L43">            boolean ret = pkgdir.mkdirs();</span>
<span class="pc bpc" id="L44" title="1 of 2 branches missed.">            if (!ret) {</span>
<span class="nc" id="L45">                System.out.println(&quot;Cannnot create directory: &quot; + path);</span>
<span class="nc" id="L46">                System.exit(1);</span>
            }
<span class="pc bnc" id="L48" title="All 2 branches missed.">        } else if (!pkgdir.isDirectory()) {</span>
            // not a directory
<span class="nc" id="L50">            System.out.println(path + &quot; is not a directory.&quot;);</span>
<span class="nc" id="L51">            System.exit(1);</span>
        }
<span class="fc" id="L53">        File file = new File(pkgdir, TYPE_NAME + &quot;.java&quot;);</span>
<span class="fc" id="L54">        FileWriter w = null;</span>
        try {
<span class="fc" id="L56">            w = new FileWriter(file);</span>
<span class="fc" id="L57">            w.write(&quot;// Do not edit!\n// File generated by org.apache.zookeeper&quot;</span>
                    + &quot;.version.util.VerGen.\n&quot;);
<span class="fc" id="L59">            w.write(&quot;/**\n&quot;);</span>
<span class="fc" id="L60">            w.write(&quot;* Licensed to the Apache Software Foundation (ASF) under one\n&quot;);</span>
<span class="fc" id="L61">            w.write(&quot;* or more contributor license agreements.  See the NOTICE file\n&quot;);</span>
<span class="fc" id="L62">            w.write(&quot;* distributed with this work for additional information\n&quot;);</span>
<span class="fc" id="L63">            w.write(&quot;* regarding copyright ownership.  The ASF licenses this file\n&quot;);</span>
<span class="fc" id="L64">            w.write(&quot;* to you under the Apache License, Version 2.0 (the\n&quot;);</span>
<span class="fc" id="L65">            w.write(&quot;* \&quot;License\&quot;); you may not use this file except in compliance\n&quot;);</span>
<span class="fc" id="L66">            w.write(&quot;* with the License.  You may obtain a copy of the License at\n&quot;);</span>
<span class="fc" id="L67">            w.write(&quot;*\n&quot;);</span>
<span class="fc" id="L68">            w.write(&quot;*     http://www.apache.org/licenses/LICENSE-2.0\n&quot;);</span>
<span class="fc" id="L69">            w.write(&quot;*\n&quot;);</span>
<span class="fc" id="L70">            w.write(&quot;* Unless required by applicable law or agreed to in writing, software\n&quot;);</span>
<span class="fc" id="L71">            w.write(&quot;* distributed under the License is distributed on an \&quot;AS IS\&quot; BASIS,\n&quot;);</span>
<span class="fc" id="L72">            w.write(&quot;* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n&quot;);</span>
<span class="fc" id="L73">            w.write(&quot;* See the License for the specific language governing permissions and\n&quot;);</span>
<span class="fc" id="L74">            w.write(&quot;* limitations under the License.\n&quot;);</span>
<span class="fc" id="L75">            w.write(&quot;*/\n&quot;);</span>
<span class="fc" id="L76">            w.write(&quot;\n&quot;);</span>
<span class="fc" id="L77">            w.write(&quot;package &quot; + PACKAGE_NAME + &quot;;\n\n&quot;);</span>
<span class="fc" id="L78">            w.write(&quot;public interface &quot; + TYPE_NAME + &quot; {\n&quot;);</span>
<span class="fc" id="L79">            w.write(&quot;    public static final int MAJOR=&quot; + version.maj + &quot;;\n&quot;);</span>
<span class="fc" id="L80">            w.write(&quot;    public static final int MINOR=&quot; + version.min + &quot;;\n&quot;);</span>
<span class="fc" id="L81">            w.write(&quot;    public static final int MICRO=&quot; + version.micro + &quot;;\n&quot;);</span>
<span class="fc bfc" id="L82" title="All 2 branches covered.">            w.write(&quot;    public static final String QUALIFIER=&quot;</span>
                    + (version.qualifier == null ? null :
                        &quot;\&quot;&quot; + version.qualifier + &quot;\&quot;&quot;)
                    + &quot;;\n&quot;);
<span class="pc bpc" id="L86" title="1 of 2 branches missed.">            if (rev &lt; 0) {</span>
<span class="nc" id="L87">                System.out.println(&quot;Unknown REVISION number, using &quot; + rev);</span>
            }
<span class="fc" id="L89">            w.write(&quot;    public static final int REVISION=&quot; + rev + &quot;;\n&quot;);</span>
<span class="fc" id="L90">            w.write(&quot;    public static final String BUILD_DATE=\&quot;&quot; + buildDate</span>
                    + &quot;\&quot;;\n&quot;);
<span class="fc" id="L92">            w.write(&quot;}\n&quot;);</span>
<span class="nc" id="L93">        } catch (IOException e) {</span>
<span class="nc" id="L94">            System.out.println(&quot;Unable to generate version.Info file: &quot;</span>
<span class="nc" id="L95">                    + e.getMessage());</span>
<span class="nc" id="L96">            System.exit(1);</span>
        } finally {
<span class="pc bpc" id="L98" title="5 of 6 branches missed.">            if (w != null) {</span>
                try {
<span class="pc" id="L100">                    w.close();</span>
<span class="nc" id="L101">                } catch (IOException e) {</span>
<span class="nc" id="L102">                    System.out.println(&quot;Unable to close file writer&quot;</span>
<span class="nc" id="L103">                            + e.getMessage());</span>
<span class="pc" id="L104">                }</span>
            }
        }
<span class="fc" id="L107">    }</span>

<span class="pc" id="L109">    public static class Version {</span>
        public int maj;
        public int min;
        public int micro;
        public String qualifier;
    }

    public static Version parseVersionString(String input) {
<span class="fc" id="L117">        Version result = new Version();</span>

<span class="fc" id="L119">        Pattern p = Pattern.compile(&quot;^(\\d+)\\.(\\d+)\\.(\\d+)((\\.\\d+)*)(-(.+))?$&quot;);</span>
<span class="fc" id="L120">        Matcher m = p.matcher(input);</span>

<span class="pc bpc" id="L122" title="1 of 2 branches missed.">        if (!m.matches()) {</span>
<span class="nc" id="L123">            return null;</span>
        }
<span class="fc" id="L125">        result.maj = Integer.parseInt(m.group(1));</span>
<span class="fc" id="L126">        result.min = Integer.parseInt(m.group(2));</span>
<span class="fc" id="L127">        result.micro = Integer.parseInt(m.group(3));</span>
<span class="pc bpc" id="L128" title="1 of 2 branches missed.">        if (m.groupCount() == 7) {</span>
<span class="fc" id="L129">            result.qualifier = m.group(7);</span>
        } else {
<span class="nc" id="L131">            result.qualifier = null;</span>
        }
<span class="fc" id="L133">        return result;</span>
    }

    /**
     * Emits a org.apache.zookeeper.version.Info interface file with version and
     * revision information constants set to the values passed in as command
     * line parameters. The file is created in the current directory. &lt;br&gt;
     * Usage: java org.apache.zookeeper.version.util.VerGen maj.min.micro[-qualifier]
     * rev buildDate
     *
     * @param args
     *            &lt;ul&gt;
     *            &lt;li&gt;maj - major version number
     *            &lt;li&gt;min - minor version number
     *            &lt;li&gt;micro - minor minor version number
     *            &lt;li&gt;qualifier - optional qualifier (dash followed by qualifier text)
     *            &lt;li&gt;rev - current SVN revision number
     *            &lt;li&gt;buildDate - date the build
     *            &lt;/ul&gt;
     */
    public static void main(String[] args) {
<span class="nc bnc" id="L154" title="All 2 branches missed.">        if (args.length != 3)</span>
<span class="nc" id="L155">            printUsage();</span>
        try {
<span class="nc" id="L157">            Version version = parseVersionString(args[0]);</span>
<span class="nc bnc" id="L158" title="All 2 branches missed.">            if (version == null) {</span>
<span class="nc" id="L159">                System.err.println(</span>
                        &quot;Invalid version number format, must be \&quot;x.y.z(-.*)?\&quot;&quot;);
<span class="nc" id="L161">                System.exit(1);</span>
            }
            int rev;
            try {
<span class="nc" id="L165">                rev = Integer.parseInt(args[1]);</span>
<span class="nc" id="L166">            } catch (NumberFormatException e) {</span>
<span class="nc" id="L167">                rev = -1;</span>
<span class="nc" id="L168">            }</span>
<span class="nc" id="L169">            generateFile(new File(&quot;.&quot;), version, rev, args[2]);</span>
<span class="nc" id="L170">        } catch (NumberFormatException e) {</span>
<span class="nc" id="L171">            System.err.println(</span>
                    &quot;All version-related parameters must be valid integers!&quot;);
<span class="nc" id="L173">            throw e;</span>
<span class="nc" id="L174">        }</span>
<span class="nc" id="L175">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>